<?php
/**
 * The template for displaying demo plugin content.
 *
 * Override this template by copying it to yourtheme/wcmps-advance-shipping/wcmps-advance-shipping_template_table_rate.php
 *
 * @author 		WC Marketplace
 * @package 	wcmps-advance-shipping/Templates
 * @version     0.0.1
 */
global $WCMp_Advance_Shipping, $wpdb, $WCMp;
$vendor_user_id = get_current_user_id();
$shipping_class_id = get_user_meta($vendor_user_id, 'shipping_class_id', true);
if (!$shipping_class_id) {
    $shipping_term = get_term_by('slug', $vendor_data->user_data->user_login . '-' . $vendor_user_id, 'product_shipping_class', ARRAY_A);
    if (!$shipping_term) {
        $shipping_term = wp_insert_term($vendor_data->user_data->user_login . '-' . $vendor_user_id, 'product_shipping_class');
    }
    if (!is_wp_error($shipping_term)) {
        $shipping_term_id = $shipping_term['term_id'];
        update_user_meta($vendor_user_id, 'shipping_class_id', $shipping_term['term_id']);
        add_woocommerce_term_meta($shipping_term['term_id'], 'vendor_id', $vendor_user_id);
        add_woocommerce_term_meta($shipping_term['term_id'], 'vendor_shipping_origin', get_option('woocommerce_default_country'));
    }
}
$shipping_class_id = $shipping_term_id = get_user_meta($vendor_user_id, 'shipping_class_id', true);
$raw_zones = WC_Shipping_Zones::get_zones();
$raw_zones[] = array('id' => 0);
foreach ($raw_zones as $raw_zone) {
    $zone = new WC_Shipping_Zone($raw_zone['id']);
    $raw_methods = $zone->get_shipping_methods();
    foreach ($raw_methods as $raw_method) {
        if ($raw_method->id == 'table_rate') {
            $table_rates = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}woocommerce_shipping_table_rates WHERE `rate_class` = {$shipping_class_id} AND `shipping_method_id` = {$raw_method->instance_id} order by 'shipping_method_id' ", OBJECT);
            ?>
            <input type="hidden" name="shipping_method_id" value="<?php echo $raw_method->instance_id; ?>" />
            <input type="hidden" name="shipping_class_id" value="<?php echo $shipping_class_id; ?>" />
            <h2 class="wcmp_black_headding"><?php _e('Table Rates: ', 'wcmp-advance-shipping'); echo $zone->get_zone_name(); ?></h2>
            <div class="wcmp_table_holder">
                <table class="table wcmp_table_rate_shipping widefat striped">
                    <tbody>
                        <tr>
                            <td></td>
                            <td><strong><?php _e('Condition', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('Min', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('Max', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('Row cost', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('Item cost', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('Kg cost', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('% cost', 'wcmp-advance-shipping'); ?></strong></td>
                            <td><strong><?php _e('Label', 'wcmp-advance-shipping'); ?></strong></td>
                        </tr>
                        <?php
                        if (count($table_rates) > 0) {
                            foreach ($table_rates as $table_rate) {
                                $WCMp_Advance_Shipping->template->get_template('wcmp_advance_shipping_template_table_rate_item.php', array('option' => $table_rate, 'shipping_method_id' => $raw_method->instance_id));
                            }
                        } else {
                            $option = new stdClass();
                            $option->rate_id = '';
                            $option->rate_class = $shipping_class_id;
                            $option->rate_condition = '';
                            $option->rate_min = '';
                            $option->rate_max = '';
                            $option->rate_cost = '';
                            $option->rate_cost_per_item = '';
                            $option->rate_cost_per_weight_unit = '';
                            $option->rate_cost_percent = '';
                            $option->rate_label = '';
                            $WCMp_Advance_Shipping->template->get_template('wcmp_advance_shipping_template_table_rate_item.php', array('option' => $option, 'shipping_method_id' => $raw_method->instance_id));
                        }
                        ?>
                    </tbody>
                    <tfoot>
                        <tr>
                            <td colspan="5">
                                <button type="button" class="wcmp_add_tablerate_item btn btn-default"><?php _e('Add Shipping Rate', 'wcmp-advance-shipping') ?></button>
                            </td>
                            <td colspan="4">
                                <button style="float: right;" type="button" name="wcmp_remove_table_rate_item" class="wcmp_remove_table_rate_item btn btn-default"><?php _e('Delete selected rows', 'wcmp-advance-shipping') ?></button>
                            </td>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <?php
        }
    }
}
?>
<script type="text/javascript">
    jQuery(document).ready(function ($) {
        $('.wcmp_add_tablerate_item').on('click', function () {
            var itemCount = $(this).closest('table').find('tbody tr').length;
            var item = $(this).closest('table').find('tbody tr:last').clone();
            item.find('input, select').each(function (index, element) {
                var elm = $(this);
                elm.val('');
                if (elm.data('name') === 'rate_min' || elm.data('name') === 'rate_max') {
                    elm.attr('disabled', 'disabled');
                }
                var name = 'wcmp_table_rate[' + elm.data('instance_id') +'][' + itemCount + '][' + elm.data('name') + ']';
                elm.attr('name', name);
            });
            $(this).closest('table').find('tbody').append(item);
        });

        $('.wcmp_remove_table_rate_item').on('click', function () {
            var checkedRate = [];
            $('.wcmp_table_rate_shipping input[type=checkbox]').each(function () {
                if ($(this).is(':checked') && $(this).val() !== '') {
                    checkedRate.push($(this).val());
                }
            });
            if (checkedRate.length > 0) {
                var data = {
                    action: 'delete_table_rate_shipping_row',
                    rate_id: checkedRate
                };
                $.post('<?php echo admin_url('admin-ajax.php'); ?>', data, function (response) {
                    window.location = window.location.href;
                });
            }
        });
    });

    function toggleDisableRate(element) {
        var self = jQuery(element);
        if (self.val() == '') {
            self.parents().eq(1).children().eq(2).find('input').attr('disabled', 'disabled');
            self.parents().eq(1).children().eq(3).find('input').attr('disabled', 'disabled');
        } else {
            self.parents().eq(1).children().eq(2).find('input').removeAttr('disabled');
            self.parents().eq(1).children().eq(3).find('input').removeAttr('disabled');
        }
    }
</script>